package io.gitlab.jfronny.dynres;

import me.sargunvohra.mcmods.autoconfig1u.ConfigData;
import me.sargunvohra.mcmods.autoconfig1u.annotation.Config;
import me.sargunvohra.mcmods.autoconfig1u.shadowed.blue.endless.jankson.Comment;

@Config(name = "dynres")
public class Cfg implements ConfigData {
    @Comment("The base of the link to send to client. This is equal to the address for clients to enter (requires a restart)")
    public String baseLink = "http://127.0.0.1";

    @Comment("The port to use for hosting the file. Use 0 for a random one (requires a restart)")
    public int port = 0;

    @Comment("The number of allowed concurrent downloads. Higher values prevent errors on clients but can increase load")
    public int maxConnections = 20;

    @Comment("The relative path to the resources zip. Expect strange behaviour if changed")
    public String resourcesFile = "resources.zip";

    @Comment("Set to true to provide a hash to clients. Changes to the pack will require a server restart with this")
    public boolean hashResources = false;
}
